! This examples show how the column() function is used.
! The column by name is used to get a column and rename it.
! The column by number is used to iterate over all
! columns in the table to output the name, type and units.
program example_column

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  integer i

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"some table",100)
  col = addColumn(tab,"col1",INTEGER32,units="m1",comment="in32 column")
  col = addColumn(tab,"col2",INTEGER32,units="m2",comment="in32 column")
  col = addColumn(tab,"col3",INTEGER32,units="m3",comment="in32 column")

  col = column( tab, "col2", MODIFY )
  call rename( col, "col4" )

  do i =0, numberOfColumns( tab ) - 1
    col = column( tab, i, READ )
    write(*,*) name( col ), columnDataType( col ), units( col )
  end do

  call release(set)

end program example_column
