! This example shows how to use the int8Array2Data interface.
! In the example a dataset is created (opened) containing
! a table with 2 vector arrays.
!
! The second array has the same data type as the first; this
! is ensured by using the arrayDataType() function to determine
! the data type of the first array.
!
! The array is then initialised,
program example_arrayvectordata

  use dal
  use errorhandling

  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ArrayT) arr1, arr2
  integer(kind=INT8), dimension(:), pointer :: a1, a2
  integer, dimension(1), parameter :: s = (/ 3 /)
  integer :: i,n

  ! create a set
  set = dataSet("test.dat",CREATE)
  arr1 = addArray( set, "array1", INTEGER8, s, "km", "array comment" )
  arr2 = addArray( set, "array2", INTEGER8, s, "km", "array comment" )

  ! fill with unique numbers

  n = 0
  a1 => int8VectorData(arr1)
  a2 => int8VectorData(arr2)
  do i=0,2 
    a1(i) = n
    a2(i) = a1(i)
    n = n + 1
  end do

  call release(arr1)
  call release(arr2)
  call release(set)

end program example_arrayvectordata
