! This example shows how the mode()
! function is used.
function addTableToSet( s, n, r )

  use dal
  
  implicit none

  type(DataSetT), intent(in) :: s
  character(len=*), intent(in) :: n
  integer, intent(in) :: r
  type(TableT) :: addTableToSet

  if( mode( s ).eq.READ ) then
    write(*,*) 'The table with name ', n, ' is read only'
  else
    addTableToSet = addTable(s,n,r)
  end if
end function addTableToSet

program example_mode

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(BlockT) blk
  integer i
  type(TableT) :: addTableToSet

  set = dataSet("test.dat",CREATE)
  tab = addTableToSet(set,"table1",10)
  call release( set )

  set = dataSet("test.dat",READ)
  tab = addTableToSet(set,"table2",10)
  call release( set )

end program example_mode
