! This examples shows how the numberOfColumns()
! function is used.
program example_numberofcolumns

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  integer i

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"some table",100)

  col = addColumn(tab,"bool",BOOLEAN)
  col = addColumn(tab,"int8",INTEGER8,units="cm",comment="int8 column")
  col = addColumn(tab,"int16",INTEGER16,units="dm",comment="int16 column")
  col = addColumn(tab,"int32",INTEGER32,units="m",comment="in32 column")
  col = addColumn(tab,"real32",REAL32,units="Dm",comment="real32 column")
  col = addColumn(tab,"real64",REAL64,units="hm",comment="real64 column")
  col = addColumn(tab,"string",STRING,comment="string column",dimensions=(/80/))

  write(*,*) numberOfColumns( tab ) ! 7 columns

  ! For each column, display the name and
  ! add an attribute.
  do i=0, numberOfColumns( tab ) - 1
    col = column( tab, i, MODIFY )
    write(*,*) name( col )
    call setAttribute( col, "TLMAX", 10, "tlmax attribute" )
  end do

  call release(set)

end program example_numberofcolumns
