! This example shows how the qualifiedName
! interface is used.
program example_qualifiedname

  use dal

  type(DataSetT) :: set
  type(ArrayT) :: arr
  type(TableT) :: tab
  type(ColumnT) :: col
  type(AttributeT) :: att

  set = dataSet("test.dat",create)
  call setAttribute(set,"sbool",.false.,"set bool comment")

  arr = addArray(set,"array",integer32, dimensions=(/ 1,2,3 /))
  call setAttribute(arr,"abool",.true.,"arr bool comment")

  tab = addTable(set,"table",10)
  call setAttribute(tab,"tbool",.false.,"tab bool comment")

  col = addColumn(tab,"column",INT32,units="UNITS",comment="Column")
  call setAttribute(col,"tlmin",1_int32,"int32 unit","col int32 comment")

  write(*,*) "qualified data set name: ", qualifiedName( set ) ! test.dat
  att = attribute( set, "sbool" )
  write(*,*) "qualified data set attribute name: ", qualifiedName( att ) !"test.dat:sbool
  write(*,*) "qualified table name: ", qualifiedName( tab )! test.dat:table
  att = attribute( tab, "tbool" )
  write(*,*) "qualified table attribute name: ", qualifiedName( att ) ! test.dat:table:tbool
  write(*,*) "qualified array name: ", qualifiedName( arr ) ! test.dat:array
  att = attribute( arr, "abool" )
  write(*,*) "qualified array attribute name: ", qualifiedName( att ) ! test.dat:array:abool
  write(*,*) "qualified column name: ", qualifiedName( col ) ! test.dat:table:column
  att = attribute( col, "tlmin" )
  write(*,*) "qualified array attribute name: ", qualifiedName( att ) ! test.dat:table:column:tlmin

  call release(set)

end program example_qualifiedname
