! This example shows how string attributes are used.
! The program creates a dataset containing two string attributes,
! together with a table containing two string attributes.
! The attributes are then accessed, by name, with
! the stringAttribute() function.
! Also, it is shown how to access the attributes by position.
program example_stringattribute
   
  use dal
  use errorhandling
  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(AttributeT) att
  integer i

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"string1","abcdef","string comment")
  call setAttribute(set,"string2","ghijkl","string comment")
   
  tab = addTable(set,"table",10);
  call setAttribute(tab,"string1","abcdef","string comment")
  call setAttribute(tab,"string2","ghijkl","string comment")

  write(*,*) stringAttribute( set, "string1" ) ! output 'abcdef
  write(*,*) stringAttribute( set, "string2" ) ! output 'ghijkl'
  write(*,*) stringAttribute( tab, "string1" ) ! output 'abcdef
  write(*,*) stringAttribute( tab, "string2" ) ! output 'ghijkl'

  do i = 0, numberOfAttributes( set ) - 1
  	att = attribute( set, i )
	write(*,*) stringAttribute( att ) ! output the sequence 'abcdef', 'ghijkl'
  end do

  call release(set)
   
end program example_stringattribute
