#include <dal.h>
#include <stdio.h>
#include <math.h>

int main()
{
  DataSet *set;
  Table *tab;
  SubTable *st;
  ColumnData *xData, *yData, *rData;

  set = dataSet("test.dat",MODIFY);
  tab = table(set,"events",MODIFY);
  st = subTable(tab);
  xData = subTableAddColumn(tab,"x",READ);
  yData = subTableAddColumn(tab,"y",READ);
  rData = subTableAddColumn(tab,"r",CREATE);

  while (subTableNext(st)) {
    unsigned int i;
    int16 *x, *y;
    real64 *r;

    x = int16Data(xData);
    y = int16Data(yData);
    r = real64Data(rData);

    for (i = 0; i < subTableCount(st); ++i) {
      printf("%hd %hd\n", x[i], y[i]);
      r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
    }
  }

  dataSetRelease(set);

  return 0;
}

