using namespace std;
#include <Dal.h>
#include <iostream>
#include <cmath>

int main()
{
  DataSet* set = dataSetServer->open("test.dat",
	DataSet::Modify);
  Table* tab = set->table("events",Table::Modify);
  SubTable s(tab);
  ColumnData *xData = s.addColumn("x",Column::Read);
  ColumnData *yData = s.addColumn("y",Column::Read);
  ColumnData *rData = s.addColumn("r",Column::Create);

  while (s.next()) {
    int16  *x = xData->int16Data();
    int16  *y = yData->int16Data();
    real64 *r = rData->real64Data();
    for (unsigned i = 0; i < s.count(); ++i) {
      clog << x[i] << ' ' << y[i] << endl;
      r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
    }
  }

  delete set;

  return 0;
}
