module autof90

use dal

type(ColumnT) :: xCol, yCol, rCol

contains

  subroutine proc(tab)
    type(TableT) :: tab
    integer(kind=int16), dimension(:), pointer :: x,y
    real(kind=double), dimension(:), pointer :: r

    x => int16Data(xCol)
    y => int16Data(yCol)
    r => real64Data(rCol)
    write(*,*) x, y
    r = sqrt( sqr(x) + sqr(y) )
  end subroutine

  subroutine auto()
    type(DataSetT) set
    type(TableT) tab

    set = dataSet("test.dat",MODIFY)
    tab = table(set,"events",MODIFY)
    xCol = column(tab,"x",READ)
    yCol = column(tab,"y",READ)
    rCol = column(tab,"r",CREATE)
    call forEachSubTable(st, proc)
    call release(set)
  end subroutine

end module
