
program test

  use dal

  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ArrayT) arr
  integer i

  set = dataSet("test.dat",CREATE)
  arr = addArray(set, "block0", INTEGER32, (/ 3,4,2 /), units="mm" )
  arr = addArray(set, "block1", INTEGER32, (/ 3,4,2 /), units="mm" )
  tab = addTable(set, "block2", 10 )
  tab = addTable(set, "block3", 10 )

  if( numberOfBlocks( set ) /= 4 ) then
    call error( "internalError", "number of blocks incorrect" )
  end if

  do i = 0, numberOfBlocks( set )

    if( blockType( set, 0 ) /= ARRAY_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if
    if( blockType( set, "block0" ) /= ARRAY_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if
    if( blockType( block( set, 0, READ )) /= ARRAY_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if

    if( blockType( set, 1 ) /= ARRAY_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if
    if( blockType( set, "block1" ) /= ARRAY_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if
    if( blockType( block( set, 1, READ )) /= ARRAY_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if

    if( blockType( set, 2 ) /= TABLE_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if
    if( blockType( set, "block2" ) /= TABLE_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if
    if( blockType( block( set, 2, READ )) /= TABLE_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if

    if( blockType( set, 3 ) /= TABLE_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if
    if( blockType( set, "block3" ) /= TABLE_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if
    if( blockType( block( set, 3, READ )) /= TABLE_BLOCK ) then
      call error( "internalError", "incorrect block type" )
    end if

  end do

  call release(set)

end program test
