program test

  use dal
  use errorhandling

  implicit none

  integer, parameter :: nRows = 1000
  integer, dimension(1), parameter :: size1 = (/ 5 /)
  integer, dimension(2), parameter :: size2 = (/ 5,2 /)
  integer :: i, j, k

  type(DataSetT) :: set
  type(TableT) :: tab
  type(ColumnT) :: col

  real(kind=single), dimension(:,:), pointer :: r32
  integer(kind=int32), dimension(:,:,:), pointer :: i32

  set = dataSet("test.dat",Create)
  tab = addTable(set,"someTable",nRows)

  col = addColumn(tab,"real32",Real32,units="m", &
	dimensions=size1,comment="real32 data")

  r32 => real32vectorData(col)
  
  do i=0,size(r32,1)-1
    do j=0,size(r32,2)-1
      r32(i,j) = i + 0.1 * j
    end do
  end do

  col = addColumn(tab,"int32",Integer32,units="mm", &
	comment="int32 data",dimensions=size2);

  i32 => int32Array2Data(col)

  do i=0,size(i32,1)-1
    do j=0,size(i32,2)-1
      do k=0,size(i32,3)-1
        i32(i,j,k) = 100*i + 10*j + k
      end do
    end do
  end do

  call release(set)

end program

