
program test

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"some table",100)

  col = addColumn( tab,"bool",BOOLEAN, units="kg" )
  if( units( col ) /= "kg" ) then
    call error("testFailed","wrong units" )
  end if

  call release(set)

  set = dataSet("test.dat",MODIFY)
  tab = table(set,"some table")
  col = column(tab,"bool",MODIFY)
  if( units( col ) /= "kg" ) then
    call error("testFailed","wrong units" )
  end if
  call setUnits( col, "mm" )
  if( units( col ) /= "mm" ) then
    call error("testFailed","wrong units" )
  end if

  call release(set)

  set = dataSet("test.dat",READ)
  tab = table(set,"some table")
  col = column(tab,"bool",MODIFY)
  if( units( col ) /= "mm" ) then
    call error("testFailed","wrong units" )
  end if

  call release(set)

end program test
