using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// January 2002
//


#include<Dal.h>
#include<iostream>
#include<cassert>

#include<cstdlib>
#include<cstring>
#include<fitsio.h>
#include<longnam.h>

int main()
{


  // cfitsio < 2.400 cannot do this
  // At cfitsio 2.400 this will fail if ne tries to write VLV columns 
  // of unsigned integer types.

  {
    int N = 10;
    int *arr, i;
    int status = 0;
    fitsfile *fptr;
    char *ttype1[] = { "Ivalue", "Jothervalue"};
    char *tform1[] = { "1PI", "1PJ"};
    char *tunit1[] = { "s", "s"};
    char name1[] = "X1";
    arr = static_cast<int *>(malloc(N*sizeof(int)));
    for (i=0; i<N; ++i)
      arr[i] = i;
    fits_create_file(&fptr, "!cfits.ds", &status);
    printf("%d-", status);
    fits_create_tbl(fptr, BINARY_TBL, 0, 0, ttype1, tform1, tunit1,
		    name1, &status);
    printf("%d-", status);

    fits_insert_col(fptr, 1, ttype1[0], tform1[0], &status);
    printf("%d-", status);
    fits_write_col(fptr, TSHORT, 1, 1, 1, N, arr, &status);
    printf("%d-", status);
    fits_insert_col(fptr, 2, ttype1[1], tform1[1], &status);
    printf("%d-", status);
    fits_write_col(fptr, TLONG, 2, 1, 1, N, arr, &status);
    printf("%d-", status);

    fits_close_file(fptr, &status);        
    printf("%d\n", status);

    assert(status == 0);

  }

  // check that the dal understands the output of cfitsio
  {
    std::string name("cfits.ds:X1:Ivalue");
    DataSet * set = dataSetServer->open(name, Dal::Read);
    Table * tab = set->table(name);
    Column * col = tab->column(name);
    std::cerr << col->name() << std::endl;
    dataSetServer->close(set);
  }
    
}

  
